﻿Public Class AirFilter
    ' class variables.

    Public strCar As String
    Dim service As New Services()

    Private Sub AirFilter_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Load system date into date label.



        Dim dtTodayDate As Date
        dtTodayDate = Today
        Me.lblDate.Text = CStr(dtTodayDate)

        ' Load Mike's car model in label.
        Me.lblCarModel.Text = "For Your " & strCar

        ' Load last airfilter miles, last date air filter serviced, and combo box of years serviced.
        lblMiles.Text = CStr(service.GetCarMilesAF())
        lblLastDateFilterChanged.Text = CStr(service.GetLastChangeDateOfAirFilter())
        cboTotalAFChangeYR.Items.AddRange(service.LoadAirFilterComboBox().ToArray)
    End Sub

    Private Sub btnChangingAFNow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChangingAFNow.Click
        ' Allows current milage and change date entered by users to be inserted into database.

        If IsValid() Then
            ' Verify user really wants to save data to database after clicking the button.

            Dim submitMilageDate As DialogResult = MessageBox.Show("Please Ensure You Have Entered The Correct Milage and Date For Your Vehicle." & _
           " Are you sure you want to save the information entered to the database?", "Save Data", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

            If submitMilageDate = Windows.Forms.DialogResult.No Then
                txtCurrentMiles.Text = String.Empty
                txtDateAirFilterChanged.Text = String.Empty
                txtCurrentMiles.Focus()
                txtCurrentMiles.SelectAll()
            Else
                'call ChangeAirFilter method in serivce class to insert service miles and date into service table.

                service.ChangeAirFilter(CSng(txtCurrentMiles.Text.Trim), CDate(txtDateAirFilterChanged.Text.Trim), CDate(lblDate.Text.Trim))
                btnChangingAFNow.Enabled = False
                ' Add 15,000 miles to latest Air Filter milage and 9 months
                ' to the last date the Air Filter was change. 
                ' Display Next Date/Miles Air Filter needs to be changed.

                service.NextAirfilterChange()
            End If
        End If
    End Sub

    Private Sub cboTotalAFChangeYR_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cboTotalAFChangeYR.Validating
        ' Allows user to select year from list box and displays number of times
        ' air filter has been changed for that year.

        If cboTotalAFChangeYR.SelectedIndex = -1 Then
            MessageBox.Show("You selected the drop down box for number of times your air filter has been changed " & _
                            "for that year, but you didn't select a year." & _
                            vbCrLf & vbCrLf & "Please select a year, close, or continue working on the form.")
        ElseIf cboTotalAFChangeYR.Items.Count = 1 Then
            lblTotalYrsAFChanged.Text = "Your Air Filter Has Never Been Changed."
        ElseIf cboTotalAFChangeYR.SelectedItem.ToString = "All Years" Then
            lblTotalYrsAFChanged.Text = "Your Air Filter Has Been Changed " & _
            service.AirfilterChangedAllYears() & " Time(s)" & vbCrLf & "Since You've Owned Your Vehicle."
        Else
            lblTotalYrsAFChanged.Text = "Your Air Filter Has Been Changed " & _
            service.AirfilterChangedYears(cboTotalAFChangeYR.SelectedItem.ToString) & " Time(s)" & vbCrLf & "In The Year " & cboTotalAFChangeYR.SelectedItem.ToString & "."
        End If
    End Sub

    Private Function IsValid() As Boolean
        Return _
            Validation.IsEmpty(txtDateAirFilterChanged, "Date Air Filter Changed") AndAlso
            Validation.IsEmpty(txtCurrentMiles, "Current Miles") AndAlso
            Validation.IsNumber(txtCurrentMiles, "Current Miles") AndAlso
            Validation.IsNotNegative(txtCurrentMiles, "Current Miles") AndAlso
            Validation.IsDate(txtDateAirFilterChanged, "Date Air Filter Changed")
    End Function

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub
End Class

