﻿Imports System.Data
Imports System.Data.SqlClient
Public Class Services
    Private vehicleMaint As String = "Server=.\SQLExpress;AttachDbFilename=C:\Program Files\Microsoft SQL Server\MSSQL11.SQLEXPRESS\MSSQL\DATA\VehicleMaintPro.mdf;Database=VehicleMaintPro;Trusted_Connection=Yes;"
    Private myConnection As New SqlConnection(vehicleMaint)
    Private m_sngMilesAF As Single
    Private m_sngMilesOIL As Single
    Private m_currentMiles As Single
    Private m_dateServiced As Date
    Private m_otherDescMech As String
    Private m_otherDescMisc As String
    Private m_otherDescWT As String
    Private myQuery As String
    Private datDate As Date = Today
    Private insertOilUpdate As String
    Private dataError As Boolean = False
    Private setIdentityInsert As String

    Public Sub New(ByVal currentMiles As Single, ByVal dateServiced As Date, _
    ByVal otherDescMech As String, ByVal otherDescMisc As String, ByVal otherDescWT As String)
        Me.CurrentMiles = currentMiles
        Me.DateServiced = dateServiced
        Me.OtherDescMech = otherDescMech
        Me.OtherDescMisc = otherDescMisc
        Me.OtherDescWT = otherDescWT
    End Sub

    Public Sub New()

    End Sub

    Public Property CurrentMiles As Single
        Get
            Return m_currentMiles
        End Get
        Set(ByVal value As Single)
            m_currentMiles = value
        End Set
    End Property

    Public Property DateServiced As Date
        Get
            Return m_dateServiced
        End Get
        Set(ByVal value As Date)
            m_dateServiced = value
        End Set
    End Property

    Public Property OtherDescMech As String
        Get
            Return m_otherDescMech
        End Get
        Set(ByVal value As String)
            m_otherDescMech = value
        End Set
    End Property

    Public Property OtherDescMisc As String
        Get
            Return m_otherDescMisc
        End Get
        Set(ByVal value As String)
            m_otherDescMisc = value
        End Set
    End Property

    Public Property OtherDescWT As String
        Get
            Return m_otherDescWT
        End Get
        Set(ByVal value As String)
            m_otherDescWT = value
        End Set
    End Property

    Public Function GetLastChangeDateOfAirFilter() As String
        ' Load last date air filter changed and number of miles on that date into labels.

        Dim datLastChangeDateAF As Date
        Dim strFirstTime As String

        Try
            myConnection.Open()
            Dim myQueryDate As String
            myQueryDate = "select max(DateAFChanged) from service having max(DateAFChanged) is not null"

            Dim myCommandDate As New SqlCommand(myQueryDate, myConnection)
            myCommandDate.CommandType = CommandType.Text

            Dim myReaderDate As SqlDataReader = myCommandDate.ExecuteReader
            If myReaderDate.HasRows = False Then
                ' return empty textbox because this is the first time user is having vehicle serviced (no record in database yet).
                strFirstTime = ""
                myConnection.Close()
                Return strFirstTime
            Else
                While myReaderDate.Read()
                    datLastChangeDateAF = CDate(myReaderDate(0))
                End While
            End If
            myReaderDate.Close()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return CStr(datLastChangeDateAF)
    End Function

    Public Function GetCarMilesAF() As String
        Dim myQueryMiles As String
        Dim strMilesMessage As String = String.Empty
        Try
            myConnection.Open()
            myQueryMiles = "select AirFilterMilage from service where DateAFChanged = " &
            "(select max(DateAFChanged) from service having max(DateAFChanged) is not null)"

            Dim myCommandMiles As New SqlCommand(myQueryMiles, myConnection)
            myCommandMiles.CommandType = CommandType.Text

            Dim myReaderMiles As SqlDataReader = myCommandMiles.ExecuteReader
            If myReaderMiles.HasRows = False Then
                ' Do nothing if this is the first time user is having vehicle serviced (no record in database yet).
            Else
                While myReaderMiles.Read
                    m_sngMilesAF = CSng(myReaderMiles(0))
                    strMilesMessage = "Last date air filter changed at " & m_sngMilesAF & " miles:"
                End While
                myReaderMiles.Close()
            End If
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return strMilesMessage
    End Function

    Public Function LoadAirFilterComboBox() As List(Of String)

        'Populate combo box with Years.
        Dim intCount As Integer
        Dim myQueryCount As String
        Dim airCombo As New List(Of String)
        Try
            myConnection.Open()
            myQueryCount = "select count(distinct(substring(cast(dateAFChanged as varchar), 8, 4))) from service"

            Dim myCommandCount As New SqlCommand(myQueryCount, myConnection)
            myCommandCount.CommandType = CommandType.Text

            Dim myReaderCount As SqlDataReader = myCommandCount.ExecuteReader
            While myReaderCount.Read
                intCount = CInt(myReaderCount(0))
            End While
            myReaderCount.Close()

            Dim myQuerySelect As String
            myQuerySelect = "select distinct(substring(cast(dateAFChanged as varchar), 8, 4)) from service" &
                " where dateAFChanged is not null"

            Dim myQueryCommand As New SqlCommand(myQuerySelect, myConnection)
            myQueryCommand.CommandType = CommandType.Text

            Dim myReaderSelect As SqlDataReader = myQueryCommand.ExecuteReader
            If myReaderSelect.HasRows = False Then
                ' Do nothing
            Else
                Dim intNum As Integer = 0               ' Variable holds array index.
                Dim strYearsAfChanged(intCount - 1) As String   ' Array to hold years.
                While myReaderSelect.Read
                    strYearsAfChanged(intNum) = CStr(myReaderSelect(0))
                    intNum = intNum + 1
                End While

                ' Sort and load air filter change years into combo box.

                Array.Sort(strYearsAfChanged)

                For intNum = 0 To strYearsAfChanged.Length - 1
                    airCombo.Add(strYearsAfChanged(intNum))
                Next
            End If
            myReaderSelect.Close()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return airCombo
    End Function

    Public Sub ChangeAirFilter(ByVal currentMiles As Single, ByVal DateOfChange As Date, ByVal today As Date)
        Dim sngMiles As Single = currentMiles
        Dim datChange As Date = DateOfChange
        Dim datToday As Date = today

        Try
            myConnection.Open()

            Dim myInsert As String
            myInsert = "insert into service(Description, ServiceType, AirFilterMilage, " &
                "DateAFChanged, TodayDate) values('Air filter changed.', 'Miscellaneous', @AirFilterMilage," &
                  " convert(varchar(10), @DateAFChanged, 110), " &
                "convert(varchar(10), @TodayDate, 110))"

            Dim myCommand As New SqlCommand(myInsert, myConnection)
            Dim ra As Integer

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@AirFilterMilage"
            p1.Value = sngMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateAFChanged"
            p2.Value = datChange
            myCommand.Parameters.Add(p2)

            Dim p3 As SqlParameter = New SqlParameter()
            p3.ParameterName = "@TodayDate"
            p3.Value = datToday
            myCommand.Parameters.Add(p3)

            ra = myCommand.ExecuteNonQuery()
            MessageBox.Show("Records Inserted into SERVICE table: " & ra, "AIR FILTER MAINTENANCE")
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try
    End Sub

    Public Sub NextAirfilterChange()
        Dim dateTimeToChangeAFDate As Date
        Dim sngTimeToChangeAFMiles As Single
        Dim sngCurrentAFMilage As Single

        Try
            myConnection.Open()
            Dim myCommit = "begin transaction commit"

            Dim myCommandCommit As New SqlCommand(myCommit, myConnection)
            myCommandCommit.ExecuteNonQuery()

            Dim myQueryNextDate As String
            myQueryNextDate = "select dateadd(month,9,DateAFChanged), AirFilterMilage from service" &
                " group by AirFilterMilage,DateAFChanged having max(DateAFChanged) is not null"

            Dim myCommandNextDate As New SqlCommand(myQueryNextDate, myConnection)
            myCommandNextDate.CommandType = CommandType.Text

            Dim myReaderNextDate As SqlDataReader = myCommandNextDate.ExecuteReader

            While myReaderNextDate.Read
                dateTimeToChangeAFDate = CDate(myReaderNextDate(0))
                sngCurrentAFMilage = CSng(myReaderNextDate(1))
            End While
            myReaderNextDate.Close()

            sngTimeToChangeAFMiles = sngCurrentAFMilage + 15000


            MessageBox.Show(" Your next Air Filter Change will be at " & sngTimeToChangeAFMiles &
                           " or on " & dateTimeToChangeAFDate & ", which ever comes first.", "NEXT SERVICE DATE")
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try
    End Sub

    Public Function AirfilterChangedAllYears() As Integer
        Dim myQueryYrCount As String
        Dim intYearCount As Integer = 0

        Try
            myConnection.Open()
            myQueryYrCount = "select count(DateAFChanged) from service"

            Dim myQueryYrCommand As New SqlCommand(myQueryYrCount, myConnection)
            myQueryYrCommand.CommandType = CommandType.Text

            Dim myReaderYrCount As SqlDataReader = myQueryYrCommand.ExecuteReader
            While myReaderYrCount.Read
                intYearCount = CInt(myReaderYrCount(0))
            End While
            myReaderYrCount.Close()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return intYearCount
    End Function

    Public Function AirfilterChangedYears(ByVal selectedTotalAFChangeYR As String) As Integer
        Dim strAFYear As String = selectedTotalAFChangeYR
        Dim myQueryYrCount As String
        Dim intYearCount As Integer = 0

        Try
            myConnection.Open()
            myQueryYrCount = "select count(DateAFChanged) from service " &
                        "where DateAFChanged like '%" & strAFYear & "%'"

            Dim myQueryYrCommand As New SqlCommand(myQueryYrCount, myConnection)

            myQueryYrCommand.CommandType = CommandType.Text

            Dim myReaderYrCount As SqlDataReader = myQueryYrCommand.ExecuteReader
            While myReaderYrCount.Read
                intYearCount = CInt(myReaderYrCount(0))
            End While
            myConnection.Close()

        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return intYearCount
    End Function

    Public Function GetLastChangeDateOfOil() As String
        ' Load last date oil changed and miles on that date into labels.

        Dim datLastChangeDateOIL As Date

        Try
            myConnection.Open()
            Dim myQueryDate As String = "select max(DateOilChanged) from service having max(DateOilChanged) is not null"

            Dim myCommandDate As New SqlCommand(myQueryDate, myConnection)
            myCommandDate.CommandType = CommandType.Text

            Dim myReaderDate As SqlDataReader = myCommandDate.ExecuteReader
            If myReaderDate.HasRows = False Then
                ' Returns empty string to textbox because this is the first time user is having vehicle serviced (no record in database yet).
                myConnection.Close()
                Return Nothing
            Else
                While myReaderDate.Read()
                    datLastChangeDateOIL = CDate(myReaderDate(0))
                End While
            End If
            myReaderDate.Close()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return CStr(datLastChangeDateOIL)
    End Function

    Public Function GetCarMilesOil() As String
        Dim myQueryMiles As String
        Dim strMilesMessage As String = String.Empty
        Try
            myConnection.Open()

            myQueryMiles = "select OilMilage from service where DateOilChanged = " &
                "(select max(DateOilChanged) from service having max(DateOilChanged) is not null)"

            Dim myCommandMiles As New SqlCommand(myQueryMiles, myConnection)
            myCommandMiles.CommandType = CommandType.Text

            Dim myReaderMiles As SqlDataReader = myCommandMiles.ExecuteReader
            If myReaderMiles.HasRows = False Then
                ' Do nothing if this is the first time user is having vehicle serviced (no record in database yet).
            Else
                While myReaderMiles.Read
                    m_sngMilesOIL = CSng(myReaderMiles(0))
                    strMilesMessage = "Last date oil changed at " & m_sngMilesOIL & " miles:"
                End While
            End If
            myReaderMiles.Close()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return strMilesMessage
    End Function

    Public Function LoadOilComboBox() As List(Of String)

        Dim oilCombo As New List(Of String)

        Try
            myConnection.Open()

            Dim myQueryCount As String = "select count(distinct(substring(cast(DateOilChanged as varchar), 8, 4))) from service"

            Dim myCommandCount As New SqlCommand(myQueryCount, myConnection)
            myCommandCount.CommandType = CommandType.Text

            Dim myReaderCount As SqlDataReader = myCommandCount.ExecuteReader
            Dim intCount As Integer = 0
            While myReaderCount.Read
                intCount = CInt(myReaderCount(0))
            End While
            myReaderCount.Close()

            Dim myQuerySelect As String = "select distinct(substring(cast(DateOilChanged as varchar), 8, 4)) from service " &
                "where DateOilChanged is not null"

            Dim myCommandQuery As New SqlCommand(myQuerySelect, myConnection)
            myCommandQuery.CommandType = CommandType.Text

            Dim myReaderQuery As SqlDataReader = myCommandQuery.ExecuteReader
            If myReaderQuery.HasRows = False Then
                ' Do nothing
            Else
                Dim intNum As Integer = 0               ' Variable to hold array index.
                Dim strYearsOilChanged(intCount - 1) As String ' Array to hold years.
                While myReaderQuery.Read
                    strYearsOilChanged(intNum) = CStr(myReaderQuery(0))
                    intNum = intNum + 1
                End While
                myReaderQuery.Close()

                ' Sort and load oil change years into combo box.

                Array.Sort(strYearsOilChanged)

                For intNum = 0 To strYearsOilChanged.Length - 1
                    oilCombo.Add(strYearsOilChanged(intNum))
                Next
            End If
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return oilCombo
    End Function


    Public Sub ChangeOil(ByVal currentMiles As Single, ByVal DateOfChange As Date, ByVal today As Date)
        Dim sngOilMiles As Single = currentMiles
        Dim datOilChangeDate As Date = DateOfChange
        Dim datToday As Date = today
        Try
            myConnection.Open()
            Dim myInsert = "Insert into service(Description, ServiceType, OilMilage, DateOilChanged, " &
                " TodayDate) values('Oil changed.', 'Miscellaneous', @OilMilage, convert(varchar(10), " &
                "@DateOilChangeDate, 110), convert(varchar(10), @TodayDate, 110))"

            Dim myInsertCommand As New SqlCommand(myInsert, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@OilMilage"
            p1.Value = sngOilMiles
            myInsertCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateOilChangeDate"
            p2.Value = datOilChangeDate
            myInsertCommand.Parameters.Add(p2)

            Dim p3 As SqlParameter = New SqlParameter()
            p3.ParameterName = "@TodayDate"
            p3.Value = datToday
            myInsertCommand.Parameters.Add(p3)


            Dim ra As Integer
            ra = myInsertCommand.ExecuteNonQuery
            MessageBox.Show("Records inserted into SERVICE table: " & ra, "OIL MAINTENANCE")
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try
    End Sub

    Public Sub NextOilChange()
        Dim dateTimeToChangeAFDate As Date
        Dim sngTimeToChangeAFMiles As Single
        Dim sngCurrentOilMilage As Single

        Try
            myConnection.Open()
            Dim myCommit = "begin transaction commit"

            Dim myCommandCommit As New SqlCommand(myCommit, myConnection)
            myCommandCommit.ExecuteNonQuery()

            Dim myQueryNextDate As String = "select dateadd(month,5,max(DateOilChanged)), OilMilage from service " &
                "group by OilMilage having max(DateOilChanged) is not null"

            Dim myCommandNextDate As New SqlCommand(myQueryNextDate, myConnection)
            myCommandNextDate.CommandType = CommandType.Text

            Dim myReaderNextDate As SqlDataReader = myCommandNextDate.ExecuteReader

            While myReaderNextDate.Read
                dateTimeToChangeAFDate = CDate(myReaderNextDate(0))
                sngCurrentOilMilage = CSng(myReaderNextDate(1))
            End While
            myReaderNextDate.Close()

            sngTimeToChangeAFMiles = sngCurrentOilMilage + 5000

            MessageBox.Show(" Your next Oil Change will be at " & sngTimeToChangeAFMiles &
                                " or on " & dateTimeToChangeAFDate & ", which ever comes first.", "OIL MAINTENANCE")
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try
    End Sub

    Public Function OilChangedAllYears() As Integer
        Dim myQueryYrCount As String
        Dim intYearCount As Integer = 0

        Try
            myConnection.Open()

            myQueryYrCount = "select count(DateOilChanged) from service"

            Dim myQueryYrCommand As New SqlCommand(myQueryYrCount, myConnection)
            myQueryYrCommand.CommandType = CommandType.Text

            Dim myReaderYrCount As SqlDataReader = myQueryYrCommand.ExecuteReader
            While myReaderYrCount.Read
                intYearCount = CInt(myReaderYrCount(0))
            End While
            myReaderYrCount.Close()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return intYearCount
    End Function

    Public Function OilChangedYears(ByVal selectedTotalOilChangeYR As String) As Integer
        Dim strYearChanged As String = selectedTotalOilChangeYR
        Dim myQueryYrCount As String
        Dim intYearCount As Integer = 0

        Try
            myConnection.Open()

            myQueryYrCount = "select count(DateOilChanged) from service " &
               "where DateOilChanged like '%" & strYearChanged & "%'"

            Dim myQueryYrCommand As New SqlCommand(myQueryYrCount, myConnection)
            myQueryYrCommand.CommandType = CommandType.Text

            Dim myReaderYrCount As SqlDataReader = myQueryYrCommand.ExecuteReader
            While myReaderYrCount.Read
                intYearCount = CInt(myReaderYrCount(0))
            End While
            myReaderYrCount.Close()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
        Return intYearCount
    End Function

    Public Sub SubmitFrontBrakePadService()
        Try
            myConnection.Open()

            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Front brake pads replaced.', 'Wear And Tear', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("FRONT BRAKE SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting front brake service into database.")
        End Try
    End Sub

    Public Sub SubmitRearBrakePadService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Rear brake pads replaced.', 'Wear And Tear', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("REAR BRAKE SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting rear brake service into database.")
        End Try
    End Sub

    Public Sub SubmitFrontTireService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Front tires replaced.', 'Wear And Tear', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("FRONT TIRES SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting front tires service into database.")
        End Try
    End Sub

    Public Sub submitRearTireService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Rear tires replaced.', 'Wear And Tear', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("REAR TIRES SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting rear tires service into database.")
        End Try
    End Sub


    Public Sub SubmitWipersService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Wiper blades replaced.', 'Miscellaneous', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("WIPER BLADES SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting wiper blades service into database.")
        End Try
    End Sub

    Public Sub SubmitElectricalService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Electrical problem fixed.', 'Miscellaneous', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)
            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("ELECTRICAL SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting electrical service into database.")
        End Try
    End Sub

    Public Sub SubmitBodyAndPaintService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Body and/or paint work done.', 'Miscellaneous', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)
            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("BODY/PAINT SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting body paint service into database.")
        End Try
    End Sub

    Public Sub SubmitFluidService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Brake fluid changed.', 'Miscellaneous', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)
            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("BRAKE FLUID SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting brake fluid service into database.")
        End Try
    End Sub

    Public Sub SubmitEngineService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Engine work done.', 'Mechanical', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)
            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("ENGINE SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting engine service into database.")
        End Try
    End Sub

    Public Sub SubmitTransmissionService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Transmission work done.', 'Mechanical', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)
            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("TRANSMISSION SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting transmission service into database.")
        End Try
    End Sub

    Public Sub SubmitAltinatorService()
        Try
            myConnection.Open()

            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values('Altinator replaced.', 'Mechanical', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)
            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@ServMilage"
            p1.Value = CurrentMiles
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@DateServiced"
            p2.Value = DateServiced
            myCommand.Parameters.Add(p2)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("ALTINATOR SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting altinator service into database.")
        End Try
    End Sub

    Public Sub SubmitOtherWTService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values(@Description, 'Wear And Tear', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@Description"
            p1.Value = OtherDescWT
            myCommand.Parameters.Add(p1)


            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@ServMilage"
            p2.Value = CurrentMiles
            myCommand.Parameters.Add(p2)

            Dim p3 As SqlParameter = New SqlParameter()
            p3.ParameterName = "@DateServiced"
            p3.Value = DateServiced
            myCommand.Parameters.Add(p3)



            myCommand.ExecuteNonQuery()
            MessageBox.Show("OTHER WEAR & TEAR SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting other wear and tear services into database.")
        End Try
    End Sub

    Public Sub SubmitOtherMiscService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values(@Description, 'Miscellaneous', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@Description"
            p1.Value = OtherDescMisc
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@ServMilage"
            p2.Value = CurrentMiles
            myCommand.Parameters.Add(p2)

            Dim p3 As SqlParameter = New SqlParameter()
            p3.ParameterName = "@DateServiced"
            p3.Value = DateServiced
            myCommand.Parameters.Add(p3)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("OTHER MISCELLANEOUS SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting other miscellaneous services into database.")
        End Try
    End Sub

    Public Sub SubmitOtherMechService()
        Try
            myConnection.Open()
            myQuery = "insert into service(Description, ServiceType, ServMilage, DateServiced, TodayDate) " &
            "values(@Description, 'Mechanical', @ServMilage, convert(varchar(10), " &
            "@DateServiced, 110), getdate())"

            Dim myCommand As New SqlCommand(myQuery, myConnection)

            Dim p1 As SqlParameter = New SqlParameter()
            p1.ParameterName = "@Description"
            p1.Value = OtherDescMech
            myCommand.Parameters.Add(p1)

            Dim p2 As SqlParameter = New SqlParameter()
            p2.ParameterName = "@ServMilage"
            p2.Value = CurrentMiles
            myCommand.Parameters.Add(p2)

            Dim p3 As SqlParameter = New SqlParameter()
            p3.ParameterName = "@DateServiced"
            p3.Value = DateServiced
            myCommand.Parameters.Add(p3)

            myCommand.ExecuteNonQuery()
            MessageBox.Show("OTHER MECHANICAL SERVICE SUBMITTED!")
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show("Problem inserting other mechanical services into database.")
        End Try
    End Sub

    Public Function ShowMiscServices() As ListBox
        Dim intAirCount As Integer
        Dim intOilCount As Integer
        Dim intServMiscCount As Integer
        Dim myQueryAirCount As String
        Dim myQueryOilCount As String
        Dim myQueryServMiscCount As String
        Dim myQueryAir As String
        Dim myQueryOil As String
        Dim myQueryServMisc As String
        Dim miscList As New ListBox
        Try
            myConnection.Open()

            myQueryAirCount = "select count(*) from service where AirFilterMilage is not null "

            Dim myCommandAirCount As New SqlCommand(myQueryAirCount, myConnection)
            myCommandAirCount.CommandType = CommandType.Text

            Dim myReaderAirCount As SqlDataReader = myCommandAirCount.ExecuteReader
            While myReaderAirCount.Read
                intAirCount = CInt(myReaderAirCount(0))
            End While
            myReaderAirCount.Close()

            myQueryAir = "select Description, AirFilterMilage, DateAFChanged, " &
               "ServiceType from service where AirFilterMilage is not null order by DateAFChanged desc"

            Dim myCommandAir As New SqlCommand(myQueryAir, myConnection)
            myCommandAir.CommandType = CommandType.Text

            Dim myReaderAir As SqlDataReader = myCommandAir.ExecuteReader
            Dim intAirNum As Integer = 0
            Dim airDescrip(intAirCount) As String
            Dim airMilage(intAirCount) As String
            Dim airDate(intAirCount) As String
            Dim airServType(intAirCount) As String
            Dim strAddLineAF As String = "N"
            Dim strAddLineOil As String = "N"

            While myReaderAir.Read
                airDescrip(intAirNum) = CStr(myReaderAir(0))
                airMilage(intAirNum) = CStr(myReaderAir(1))
                airDate(intAirNum) = CStr(myReaderAir(2))
                airServType(intAirNum) = CStr(myReaderAir(3))
                intAirNum = intAirNum + 1
            End While

            For intAirNum = 0 To airDescrip.Length - 1
                If airDescrip(intAirNum) Is Nothing Then
                    'Do Nothing
                Else
                    miscList.Items.Add("DESCRIPTION:  " & airDescrip(intAirNum).Trim.PadRight(23, CChar(" ")) &
                "       MILAGE ON CAR:  " & FormatNumber(airMilage(intAirNum), 0) & "      DATE AIR FILTER CHANGED:  " &
                airDate(intAirNum) & "    SERVICE TYPE:  " & airServType(intAirNum))
                    strAddLineAF = "Y"
                End If
            Next
            If strAddLineAF = "Y" Then
                miscList.Items.Add(vbCrLf)
            End If
            myReaderAir.Close()

            myQueryOilCount = "select count(*) from service where OilMilage is not null "

            Dim myCommandOilCount As New SqlCommand(myQueryOilCount, myConnection)
            myCommandOilCount.CommandType = CommandType.Text

            Dim myReaderOilCount As SqlDataReader = myCommandOilCount.ExecuteReader
            While myReaderOilCount.Read
                intOilCount = CInt(myReaderOilCount(0))
            End While
            myReaderOilCount.Close()

            myQueryOil = "select Description, OilMilage, DateOilChanged, " &
            "ServiceType from service where OilMilage is not null order by DateOilChanged desc"

            Dim myCommandOil As New SqlCommand(myQueryOil, myConnection)
            myCommandOil.CommandType = CommandType.Text

            Dim myReaderOil As SqlDataReader = myCommandOil.ExecuteReader
            Dim intOilNum As Integer = 0
            Dim oilDescrip(intOilCount) As String
            Dim oilMilage(intOilCount) As String
            Dim oilDate(intOilCount) As String
            Dim oilServType(intOilCount) As String
            Dim strMiscOilService(intOilCount) As String
            While myReaderOil.Read
                oilDescrip(intOilNum) = CStr(myReaderOil(0))
                oilMilage(intOilNum) = CStr(myReaderOil(1))
                oilDate(intOilNum) = CStr(myReaderOil(2))
                oilServType(intOilNum) = CStr(myReaderOil(3))
                intOilNum = intOilNum + 1
            End While
            myReaderOil.Close()

            For intOilNum = 0 To oilDescrip.Length - 1
                If oilDescrip(intOilNum) Is Nothing Then
                    'Do nothing.
                ElseIf miscList.Items.Count = 0 Then
                    miscList.Items.Clear()
                    miscList.Items.Add("DESCRIPTION:  " & oilDescrip(intOilNum).Trim.PadRight(23, CChar(" ")) &
                   "       MILAGE ON CAR:  " & FormatNumber(oilMilage(intOilNum), 0) & "      DATE AIR FILTER CHANGED:  " &
                   oilDate(intOilNum) & "    SERVICE TYPE:  " & oilServType(intOilNum))
                    strAddLineOil = "Y"
                Else
                    miscList.Items.Add("DESCRIPTION:  " & oilDescrip(intOilNum) &
                        "       MILAGE ON CAR:  " & FormatNumber(oilMilage(intOilNum), 0) & "      DATE AIR FILTER CHANGED:  " &
                        oilDate(intOilNum) & "    SERVICE TYPE:  " & oilServType(intOilNum))
                    strAddLineOil = "Y"
                End If
            Next

            If strAddLineOil = "Y" Then
                miscList.Items.Add(vbCrLf)
            End If


            myQueryServMiscCount = "select count(*) from service where ServMilage is not null " &
                "and ServiceType = 'Miscellaneous'"

            Dim myCommandServMiscCount As New SqlCommand(myQueryServMiscCount, myConnection)
            myCommandServMiscCount.CommandType = CommandType.Text

            Dim myReaderServMiscCount As SqlDataReader = myCommandServMiscCount.ExecuteReader
            While myReaderServMiscCount.Read
                intServMiscCount = CInt(myReaderServMiscCount(0))
            End While
            myReaderServMiscCount.Close()

            myQueryServMisc = "select Description, ServMilage, DateServiced, " &
               "ServiceType from service where ServMilage is not null and " &
               "ServiceType = 'Miscellaneous' order by DateServiced desc"

            Dim myCommandServMisc As New SqlCommand(myQueryServMisc, myConnection)
            myCommandServMisc.CommandType = CommandType.Text

            Dim myReaderServMisc As SqlDataReader = myCommandServMisc.ExecuteReader
            Dim intServMiscNum As Integer = 0
            Dim servMiscDescrip(intServMiscCount) As String
            Dim servMiscMilage(intServMiscCount) As String
            Dim servMiscDate(intServMiscCount) As String
            Dim servMiscServType(intServMiscCount) As String
            While myReaderServMisc.Read
                servMiscDescrip(intServMiscNum) = CStr(myReaderServMisc(0))
                servMiscMilage(intServMiscNum) = CStr(myReaderServMisc(1))
                servMiscDate(intServMiscNum) = CStr(myReaderServMisc(2))
                servMiscServType(intServMiscNum) = CStr(myReaderServMisc(3))
                intServMiscNum = intServMiscNum + 1
            End While
            myReaderServMisc.Close()

            For intServMiscNum = 0 To servMiscDescrip.Length - 1
                If servMiscDescrip(intServMiscNum) Is Nothing Then
                    ' Do nothing.
                ElseIf miscList.Items.Count = 0 Then
                    miscList.Items.Clear()
                    miscList.Items.Add("DESCRIPTION:  " & servMiscDescrip(intServMiscNum).Trim.PadRight(23, CChar(" ")) &
               "       MILAGE ON CAR:  " & FormatNumber(servMiscMilage(intServMiscNum), 0) & "      DATE AIR FILTER CHANGED:  " &
               servMiscDate(intServMiscNum) & "    SERVICE TYPE:  " & servMiscServType(intServMiscNum))
                Else
                    miscList.Items.Add("DESCRIPTION:  " & servMiscDescrip(intServMiscNum).Trim.PadRight(23, CChar(" ")) &
                "       MILAGE ON CAR:  " & FormatNumber(servMiscMilage(intServMiscNum), 0) & "      DATE AIR FILTER CHANGED:  " &
                servMiscDate(intServMiscNum) & "    SERVICE TYPE:  " & servMiscServType(intServMiscNum))
                End If
            Next

            If miscList.Items.Count = 0 Then
                MessageBox.Show("There Hasn't Been Any Miscellaneous Work Done On Your Vehicle.")
            End If
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace, ex.GetType.ToString)
            miscList.Items.Clear()
        End Try
        Return miscList
    End Function

    Public Function ShowWTServices() As ListBox
        Dim intServWtCount As Integer
        Dim myQueryServWtCount As String
        Dim myQueryServWt As String
        Dim wtList As New ListBox
        Try
            myConnection.Open()

            myQueryServWtCount = "select count(*) from service where ServMilage is not null and ServiceType = 'Wear And Tear'"

            Dim myCommandServWtCount As New SqlCommand(myQueryServWtCount, myConnection)
            myCommandServWtCount.CommandType = CommandType.Text

            Dim myReaderServWtCount As SqlDataReader = myCommandServWtCount.ExecuteReader
            While myReaderServWtCount.Read
                intServWtCount = CInt(myReaderServWtCount(0))
            End While
            myReaderServWtCount.Close()

            myQueryServWt = "select Description, ServMilage, DateServiced, " &
                    "ServiceType from service where ServMilage is not null and ServiceType = 'Wear And Tear' " &
                    "order by DateServiced desc"


            Dim myCommandServWt As New SqlCommand(myQueryServWt, myConnection)
            myCommandServWt.CommandType = CommandType.Text

            Dim myReaderServWt As SqlDataReader = myCommandServWt.ExecuteReader
            Dim intServWtNum As Integer = 0                ' Variable holds array index.
            Dim servWtDescrip(intServWtCount) As String    ' arrays to hold query data for listbox.
            Dim servWtMilage(intServWtCount) As String
            Dim servWtDate(intServWtCount) As String
            Dim servWtServType(intServWtCount) As String
            While myReaderServWt.Read
                servWtDescrip(intServWtNum) = CStr(myReaderServWt(0))
                servWtMilage(intServWtNum) = CStr(myReaderServWt(1))
                servWtDate(intServWtNum) = CStr(myReaderServWt(2))
                servWtServType(intServWtNum) = CStr(myReaderServWt(3))
                intServWtNum = intServWtNum + 1
            End While
            myReaderServWt.Close()
            myConnection.Close()

            For intServWtNum = 0 To servWtDescrip.Length - 1
                If servWtDescrip(intServWtNum) = Nothing Then
                    Exit For
                Else
                    wtList.Items.Add("DESCRIPTION:  " & servWtDescrip(intServWtNum).PadRight(15, CChar(" ")) &
                "       MILAGE ON CAR:  " & FormatNumber(servWtMilage(intServWtNum), 0) & "      DATE SERVICED:  " &
                servWtDate(intServWtNum) & "    SERVICE TYPE:  " & servWtServType(intServWtNum))
                End If
            Next

            If wtList.Items.Count = 0 Then
                MessageBox.Show("There Hasn't Been Any Wear And Tear Work Done On Your Vehicle.")
            End If
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace, ex.GetType.ToString)
            wtList.Items.Clear()
        End Try
        Return wtList
    End Function

    Public Function ShowMechServices() As ListBox
        Dim intServMechCount As Integer
        Dim myQueryServMechCount As String
        Dim myQueryServMech As String
        Dim mechList As New ListBox
        Try
            myConnection.Open()

            myQueryServMechCount = "select count(*) from service where ServMilage is not null and ServiceType = 'Mechanical'"

            Dim myCommandServMechCount As New SqlCommand(myQueryServMechCount, myConnection)
            myCommandServMechCount.CommandType = CommandType.Text

            Dim myReaderServMechCount As SqlDataReader = myCommandServMechCount.ExecuteReader
            While myReaderServMechCount.Read
                intServMechCount = CInt(myReaderServMechCount(0))
            End While
            myReaderServMechCount.Close()

            myQueryServMech = "select Description, ServMilage, DateServiced, " &
                    "ServiceType from service where ServMilage is not null and ServiceType = 'Mechanical' " &
                    "order by DateServiced desc"


            Dim myCommandServMech As New SqlCommand(myQueryServMech, myConnection)
            myCommandServMech.CommandType = CommandType.Text

            Dim myReaderServMech As SqlDataReader = myCommandServMech.ExecuteReader
            Dim intServMechNum As Integer = 0                ' Variable holds array index.
            Dim servMechDescrip(intServMechCount) As String    ' arrays to hold query data for listbox.
            Dim servMechMilage(intServMechCount) As String
            Dim servMechDate(intServMechCount) As String
            Dim servMechServType(intServMechCount) As String
            While myReaderServMech.Read
                servMechDescrip(intServMechNum) = CStr(myReaderServMech(0))
                servMechMilage(intServMechNum) = CStr(myReaderServMech(1))
                servMechDate(intServMechNum) = CStr(myReaderServMech(2))
                servMechServType(intServMechNum) = CStr(myReaderServMech(3))
                intServMechNum = intServMechNum + 1
            End While
            myReaderServMech.Close()
            myConnection.Close()

            For intServMechNum = 0 To servMechDescrip.Length - 1
                If servMechDescrip(intServMechNum) = Nothing Then
                    Exit For
                Else
                    mechList.Items.Add("DESCRIPTION:  " & servMechDescrip(intServMechNum).PadRight(18, CChar(" ")) &
                    "       MILAGE ON CAR:  " & FormatNumber(servMechMilage(intServMechNum), 0) & "      DATE SERVICED:  " &
                    servMechDate(intServMechNum) & "    SERVICE TYPE:  " & servMechServType(intServMechNum))
                End If
            Next

            If mechList.Items.Count = 0 Then
                MessageBox.Show("There Hasn't Been Any Mechancial Work Done On Your Vehicle.")
                mechList.Items.Clear()
            End If
            myConnection.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace, ex.GetType.ToString)
            Return Nothing
        End Try
        Return mechList
    End Function

    Public Sub DeleteAccount()
        Try
            myConnection.Open()
            Dim strDeleteService As String = "delete from service"
            Dim strDeleteCar As String = "delete from car"
            Dim strCommit As String = "begin transaction commit"

            Dim deleteServiceCommand As New SqlCommand(strDeleteService, myConnection)
            deleteServiceCommand.ExecuteNonQuery()

            Dim deleteCarCommand As New SqlCommand(strDeleteCar, myConnection)
            deleteCarCommand.ExecuteNonQuery()

            Dim commitCommand As New SqlCommand(strCommit, myConnection)
            commitCommand.ExecuteNonQuery()

            MessageBox.Show("ACCOUNT DELETED", "User Account")
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try
    End Sub

    Public Sub UpdateFullOil()
        'Insert Date Oil changed and Full Oil Level into service table.
        Try
            myConnection.Open()
            insertOilUpdate = "update service set OilLevel = 'FULL', OilCheckDate = '" & datDate & "'"
            Dim insertOilCommand As New SqlCommand(insertOilUpdate, myConnection)
            insertOilCommand.ExecuteNonQuery()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            dataError = True
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            dataError = True
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            dataError = True
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try

        If dataError = False Then
            MessageBox.Show("Oil level of FULL has been inserted into the database on: " & datDate & vbCrLf & vbCrLf &
                            "Please check your oil again in 2 WEEKS.")
        End If
    End Sub

    Public Sub UpdateHalfOil()
        'Insert Date Oil changed and Half Full Oil Level into service table.
        Try
            myConnection.Open()
            insertOilUpdate = "update service set OilLevel = 'HALF FULL', OilCheckDate = '" & datDate & "'"
            Dim insertOilCommand As New SqlCommand(insertOilUpdate, myConnection)
            insertOilCommand.ExecuteNonQuery()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            dataError = True
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            dataError = True
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            dataError = True
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try

        If dataError = False Then
            MessageBox.Show("Oil level of HALF FULL has been inserted into the database on: " & datDate & vbCrLf & vbCrLf &
                            "Please check your oil again in 1 WEEK.")
        End If
    End Sub

    Public Sub UpdateAddOil()
        'Insert Date Oil changed and Add A Quart Oil Level into service table.
        Try
            myConnection.Open()
            insertOilUpdate = "update service set OilLevel = 'ADD A QUART', OilCheckDate = '" & datDate & "'"
            Dim insertOilCommand As New SqlCommand(insertOilUpdate, myConnection)
            insertOilCommand.ExecuteNonQuery()
            myConnection.Close()
        Catch ex As DBConcurrencyException
            dataError = True
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            dataError = True
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            dataError = True
            MessageBox.Show("Database Error # " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try

        If dataError = False Then
            MessageBox.Show("Oil level of ADD A QUART has been inserted into the database on: " & datDate & vbCrLf & vbCrLf &
                            "Please Add 1 quart of oil to your vehicle.")
        End If
    End Sub

    Public Function OilLevelChecked() As Boolean
        Dim datToday As Date = Today
        Dim datQueryDate As Date
        Dim dateFound As Boolean
        Try
            myConnection.Open()
            Dim myQuery As String = "Select OilCheckDate from service where OilCheckDate is not null"

            Dim myCommand As New SqlCommand(myQuery, myConnection)
            myCommand.CommandType = CommandType.Text
            Dim myReader As SqlDataReader = myCommand.ExecuteReader

            While myReader.Read
                datQueryDate = CDate(myReader(0))
            End While
            myReader.Close()

            If datQueryDate = datToday Then
                dateFound = True
            End If
            myConnection.Close()

            If dateFound = True Then
                Return True
            Else
                Return False
            End If
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Database Error #: " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
    End Function

    Public Sub LastCheckAndOilLevel()
        Dim oilLevel As String = ""
        Dim oilChkDate As Date
        Dim datToday As Date = Today
        Dim intNumOfDays As Integer
        Dim oilQuery As String = "Select OilCheckDate, OilLevel from service"
        Try
            myConnection.Open()
            Dim oilCommand As New SqlCommand(oilQuery, myConnection)
            oilCommand.CommandType = CommandType.Text
            Dim oilReader As SqlDataReader = oilCommand.ExecuteReader
            While oilReader.Read()
                Dim oilChk = CStr(oilReader(1))
                If oilChk = " " Then
                    oilLevel = "NEVER"
                Else
                    oilChkDate = CDate(oilReader(0))
                    oilLevel = CStr(oilReader(1))
                End If
            End While


            oilReader.Close()

            intNumOfDays = datToday.Subtract(oilChkDate).Days

            If oilLevel = "FULL" And intNumOfDays > 14 Then
                MessageBox.Show("Please check your oil level as soon as possible because it's been" & vbCrLf &
                " past 2 weeks since it was last checked.")
            ElseIf oilLevel = "FULL" And intNumOfDays < 14 Then
                MessageBox.Show("Your oil level was FULL when it was last checked on " & oilChkDate & "." & vbCrLf &
                "Please check your oil level in " & 14 - intNumOfDays & " days.")
            ElseIf oilLevel = "HALF FULL" And intNumOfDays > 7 Then
                MessageBox.Show("Your oil level was HALF FULL when it was last checked and it's been over " &
                "a week since it was checked. " & vbCrLf & "Please check it as soon as possible.")
            ElseIf oilLevel = "HALF FULL" And intNumOfDays < 7 Then
                MessageBox.Show("Your oil level was HALF FULL when it was last checked on " & oilChkDate & "." & vbCrLf &
                "Please check your oil level in " & 7 - intNumOfDays & " days.")
            ElseIf oilLevel = "ADD A QUART" Then
                MessageBox.Show("Your last oil level indicated that you needed to ADD A QUART." & vbCrLf &
                "If you didn't add a quart please do so now.")
            ElseIf oilLevel = "NEVER" Then
                MessageBox.Show("Your oil has never been checked and reported for this vehicle." & vbCrLf &
                "Please check at your earliest convenience.")
            End If
            myConnection.Close()
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency error occurred. Some rows were not updated.", "Concurrency Error")
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
        Catch ex As SqlException
            MessageBox.Show("Database Error# " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
        End Try
    End Sub

    Public Function FirstTimeServiced() As Boolean
        Dim serviceQuery As String = "Select count(*) from service"
        Dim intCount As Integer
        Try
            myConnection.Open()
            Dim serviceCommand As New SqlCommand(serviceQuery, myConnection)
            serviceCommand.CommandType = CommandType.Text
            Dim myReader As SqlDataReader = serviceCommand.ExecuteReader
            While myReader.Read
                intCount = CInt(myReader(0))
            End While
            myReader.Close()
            myConnection.Close()

            If intCount = 0 Then
                Return True
            Else
                Return False
            End If
        Catch ex As DBConcurrencyException
            MessageBox.Show("A concurrency eror occurred. Some rows were not updated", "Concurrency Error")
            Return Nothing
        Catch ex As DataException
            MessageBox.Show(ex.Message, ex.GetType.ToString)
            Return Nothing
        Catch ex As SqlException
            MessageBox.Show("Data Error# " & ex.ErrorCode & ": " & ex.Message, ex.GetType.ToString)
            Return Nothing
        End Try
    End Function
End Class
