﻿Public Class Oil
    ' Class variables.
    Public strCar As String
    Dim datLastChangeDate As Date
    Dim services As New Services()

    Private Sub Oil_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Load system date into date label.

        Dim dtTodayDate As Date
        dtTodayDate = Today
        Me.lblDate.Text = CStr(dtTodayDate)
        ' Load car model in label.

        Me.lblCarModel.Text = "For Your " & strCar

        'Load last oil change miles, last date oil change done, and combo box of years serviced.
        Me.lblMiles.Text = services.GetCarMilesOil()
        Me.lblLastDateOilChanged.Text = (CStr(services.GetLastChangeDateOfOil()))
        cboTotalOilChangeYR.Items.AddRange(services.LoadOilComboBox().ToArray)

        'Prompt user to see if Oil has been checked today. Do not display prompt if user has already
        ' submitted Oil level for the day.
        If services.OilLevelChecked() = True Or services.FirstTimeServiced() = True Then
            'Do not display prompt
        Else
            Dim oilCheck As DialogResult = MessageBox.Show("Have you checked your oil today?", "Oil Form", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

            If oilCheck = Windows.Forms.DialogResult.Yes Then
                Dim checker As New OilChecker
                checker.ShowDialog()
            Else
                services.LastCheckAndOilLevel()
            End If
        End If
    End Sub

    Private Sub btnChangingOilNow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChangingOilNow.Click
        ' Allows current milage and change date entered by users to be inserted
        ' into database.

        If IsValid() Then
            ' Verify user really wants to save data to database after clicking the button.

            Dim submitMilageDate As DialogResult = MessageBox.Show("Please Ensure You Have Entered The Correct Milage and Date For Your Vehicle. Continue Saving?" & _
            " Are you sure you want to save the information entered to the database?", "Save Data", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

            If submitMilageDate = Windows.Forms.DialogResult.No Then
                txtCurrentMiles.Text = String.Empty
                txtDateOilChanged.Text = String.Empty
                txtCurrentMiles.Focus()
                txtCurrentMiles.SelectAll()
            Else
                services.ChangeOil(CSng(txtCurrentMiles.Text.Trim), CDate(txtDateOilChanged.Text.Trim), CDate(lblDate.Text.Trim))
                btnChangingOilNow.Enabled = False

                ' Add 5,000 miles to latest Oil milage and 5 months
                ' to the last date the Air Filter was change. 
                ' Display results in message box.

                services.NextOilChange()
            End If
        End If
    End Sub

    Private Sub cboTotalOilChangeYR_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cboTotalOilChangeYR.Validating
        ' Allows user to select year from list box and displays number of times
        ' oil has been changed for that year.

        If cboTotalOilChangeYR.SelectedIndex = -1 Then
            MessageBox.Show("You selected the drop down box for number of times your oil has been changed " & _
                            vbCrLf & "for that year, but you didn't select a year." & _
                            vbCrLf & vbCrLf & "Please select a year, close, or continue working on the form.")
        ElseIf cboTotalOilChangeYR.Items.Count = 1 Then
            lblTotalYrsOilChanged.Text = "Your Oil Has Never Been Changed."
        ElseIf cboTotalOilChangeYR.SelectedItem.ToString = "All Years" Then
            lblTotalYrsOilChanged.Text = "Your Oil Has Been Changed " & _
           services.OilChangedAllYears() & " Time(s)" & vbCrLf & "Since You've Owned Your Vehicle."
        Else
            lblTotalYrsOilChanged.Text = "Your Oil Has Been Changed " & _
           services.OilChangedYears(cboTotalOilChangeYR.SelectedItem.ToString) & " Time(s)" & vbCrLf & "In The Year " & cboTotalOilChangeYR.SelectedItem.ToString & "."
        End If
    End Sub

    Private Function IsValid() As Boolean
        Return _
        Validation.IsEmpty(txtDateOilChanged, "Date Oil Changed") AndAlso
        Validation.IsEmpty(txtCurrentMiles, "Current Miles") AndAlso
        Validation.IsNumber(txtCurrentMiles, "Current Miles") AndAlso
        Validation.IsNotNegative(txtCurrentMiles, "Current Miles") AndAlso
        Validation.IsDate(txtDateOilChanged, "Date Oil Changed")
    End Function

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        ' Close OilMike form.

        Me.Close()
    End Sub
End Class