﻿Public Class Validation

    Public Shared Function IsEmpty(ByVal textbox As TextBox, ByVal name As String) As Boolean
        If textbox.Text = String.Empty Then
            MessageBox.Show("The " & name & " texbox cannot be blank. Please enter your " & name & " in the textbox.")
            textbox.Focus()
            Return False
        Else
            Return True
        End If
    End Function

    Public Shared Function IsString(ByVal textbox As TextBox, ByVal name As String) As Boolean
        If IsNumeric(textbox.Text.Trim) Then
            MessageBox.Show("The " & name & " textbox cannot be numeric. Please enter a string value in the textbox.")
            textbox.Focus()
            textbox.SelectAll()
            Return False
        Else
            Return True
        End If
    End Function

    Public Shared Function IsNumber(ByVal textbox As TextBox, ByVal name As String) As Boolean
        If Not IsNumeric(textbox.Text.Trim) Then
            MessageBox.Show("The " & name & " textbox must be numeric. Please enter a numeric value in the textbox.")
            textbox.Focus()
            textbox.SelectAll()
            Return False
        Else
            Return True
        End If
    End Function

    Public Shared Function Is4digits(ByVal textbox As TextBox, ByVal name As String) As Boolean
        Dim intYearLength = textbox.Text.Trim.Length
        If intYearLength <> 4 Then
            MessageBox.Show("The " & name & " textbox must be 4 digits long. Please enter a 4-digit value in the textbox." &
        " (Example: 2012)")
            textbox.Focus()
            textbox.SelectAll()
            Return False
        Else
            Return True
        End If
    End Function

    Public Shared Function IsNotNegative(ByVal textbox As TextBox, ByVal name As String) As Boolean
        If CInt(textbox.Text.Trim) <= 0 Then
            MessageBox.Show("The " & name & " textbox cannot be equal to or less than zero.", "Entry Error")
            textbox.Focus()
            textbox.SelectAll()
            Return False
        Else
            Return True
        End If
    End Function

    Public Shared Function IsDate(ByVal textbox As TextBox, ByVal name As String) As Boolean
        Try
            Convert.ToDateTime(textbox.Text)
            Return True
        Catch ex As Exception
            MessageBox.Show("The " & name & " textbox must be a date value.", "Entry Error")
            textbox.Focus()
            textbox.SelectAll()
            Return False
        End Try
    End Function

End Class