﻿Public Class VehicleMaintenance
    ' This application tracks the car maintenance of users 
    ' It allows them to check oil changes, air filter
    ' changes, next due dates, and other service work done to the vehicles.


    Private Sub btnEnter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnter.Click
        ' Allows new user to be created or opens application for user already created in the system.

        Dim car As New Car
        Dim blnNewUser As Boolean = car.IsNewUser

        If blnNewUser = True Then
            Me.Hide() ' Hides VehicleMaintenance form before going to NewUser form.
            Dim newUser As New NewUser
            newUser.ShowDialog()   ' Opens the NewUser form.
            Me.Close()        ' Allows program to end if NewUser form is closed.
        Else
            ' Goes to Welcome form.

            Me.Hide() ' Hides VehicleMaintenance form before going to ReturningUser form.
            car.getCarOwner()
            Me.Close()        ' Allows program to end if Welcome form is closed.

        End If

    End Sub

    Private Sub VehicleMaintenance_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Play audio sound when the form loads.
        Dim ResourceFilePathPrefix As String
        If System.Diagnostics.Debugger.IsAttached() Then

            'In Debugging mode  

            ResourceFilePathPrefix = System.IO.Path.GetFullPath(Application.StartupPath & "\..\..\resources\")

        Else

            'In Published mode  

            ResourceFilePathPrefix = Application.StartupPath & "\resources\"

        End If

        My.Computer.Audio.Play(ResourceFilePathPrefix & "car-ignition-01.wav")
        My.Computer.Audio.Play(ResourceFilePathPrefix & "car-squealy-01.wav")
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        ' End application.

        Me.Close()
    End Sub

    Private Sub btnDeleteAccount_Click(sender As System.Object, e As System.EventArgs) Handles btnDeleteAccount.Click
        ' Delete user account from database.

        Dim removemessage As String = "Are you sure you want to delete your user account?"
        Dim removeAcct As DialogResult = MessageBox.Show(removemessage, "Delete Account", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

        If removeAcct = Windows.Forms.DialogResult.Yes Then
            Dim ser As New Services
            ser.DeleteAccount()
        End If

    End Sub
End Class
